<?php

/**
 * Description of mysql_demo
 *  mysql操纵类
 * @author albafica.wang
 */
class mysql {

    private $db_host;       //数据库主机
    private $db_user;       //数据库登陆名
    private $db_pwd;        //数据库登陆密码
    private $db_name;       //数据库名
    private $db_charset;    //数据库字符编码
    private $db_pconn;      //长连接标识位
    private $debug;         //调试开启
    private $conn;          //数据库连接标识
    private $msg = "";      //数据库操纵信息

    /*
     * Description of __construct
     * 构造函数，配置数据库连接信息，初始化数据库服务器连接
     */

    public function __construct($db_host, $db_user, $db_pwd, $db_name, $db_chaeset = 'utf8', $db_pconn = false, $debug = false) {
        $this->db_host = $db_host;
        $this->db_user = $db_user;
        $this->db_pwd = $db_pwd;
        $this->db_name = $db_name;
        $this->db_charset = $db_chaeset;
        $this->db_pconn = $db_pconn;
        $this->result = '';
        $this->debug = $debug;
        $this->initConnect();
    }

    /*
     * Description of initConnect
     * 初始化数据库连接，连接数据库
     */

    public function initConnect() {
        if ($this->db_pconn) {
            $this->conn = @mysql_pconnect($this->db_host, $this->db_user, $this->db_pwd);
        } else {
            $this->conn = @mysql_connect($this->db_host, $this->db_user, $this->db_pwd);
        }
        if ($this->conn) {
            $this->query("SET NAMES " . $this->db_charset);
        } else {
            $this->halt("", "数据库连接出错");
        }
        $this->selectDb();
    }

    /*
     * Description of selectDb
     * 连接数据库
     */

    public function selectDb($dbname = "") {
        if ($dbname != "") {
            $this->db_name = $dbname;
        }
        if (!@mysql_select_db($this->db_name, $this->conn)) {
            $this->halt("", "数据库不可用");
        }
    }

    /*
     * Description of query
     * 执行SQL语句
     */

    public function query($sql) {
        $this->result = @mysql_query($sql, $this->conn);
        if ($this->result == false) {
            $this->halt($sql);
        }
    }

    /*
     * Description of select
     * 查询操作，返回查询结果
     */

    public function select($tableName, $columnName = "*", $where = "", $result_type = MYSQL_ASSOC) {
        $sql = "SELECT " . $columnName . " FROM " . $tableName;
        $sql .= $where ? " WHERE " . $where : null;
        $this->query($sql);
        return $this->fetchArray($result_type);
    }

    /*
     * Description of findAll
     * 查询数据表下所有数据并返回
     */

    public function findAll($tableName, $result_type = MYSQL_ASSOC) {
        $sql = "SELECT * FROM $tableName";
        $this->query($sql);
        return $this->fetchArray($result_type);
    }

    /*
     * Description of getOne
     * 返回第一行记录并返回
     */

    public function getOne($tableName, $columnName = "*", $where = "", $result_type = MYSQL_ASSOC) {
        $sql = "SELECT " . $columnName . " FROM " . $tableName;
        $sql .= $where ? " WHERE " . $where : null;
        $sql .= " LIMIT 1";
        $this->query($sql);
        return $this->fetchArray($result_type);
    }

    /*
     * Description of insert
     * 执行插入操作并返回插入后的ID
     */

    public function insert($tableName, $column = array()) {
        $columnName = implode('`,`', array_keys($column));
        $columnValue = implode("','", $column);
        $sql = "INSERT INTO `$tableName`(`" . $columnName . "`) VALUES('" . $columnValue . "')";
        $this->query($sql);
        return $this->insertId();
    }

    /*
     * Description of update
     * 执行更新操作并返回受影响的记录数
     */

    public function update($tableName, $column = array(), $where = "") {
        $updateValue = "";
        foreach ($column as $key => $value) {
            $updateValue .= $key . "='" . $value . "',";
        }
        $updateValue = substr($updateValue, 0, strlen($updateValue) - 1);
        $sql = "UPDATE $tableName SET $updateValue";
        $sql .= $where ? " WHERE $where" : null;
        $this->query($sql);
        return $this->affectedRows();
    }

    /*
     * Description of delete
     * 执行删除操作
     */

    public function delete($tableName, $where = "") {
        $sql = "DELETE FROM $tableName";
        $sql .= $where ? " WHERE $where" : null;
        $this->query($sql);
        return $this->affectedRows();
    }

    /*
     * Description of fetchArray
     * 遍历查询结果集并返回数组形式的结果
     */

    protected function fetchArray($result_type = MYSQL_ASSOC) {
        $resultArray = array();
        $i = 0;
        while ($result = mysql_fetch_array($this->result, $result_type)) {
            $resultArray[$i] = $result;
            $i++;
        }
        return $resultArray;
    }

    /* 返回结果集受影响的记录数 */

    public function affectedRows() {
        return @mysql_affected_rows($this->conn);
    }

    /* 返回结果集中记录数 */

    public function numRows($result) {
        return @mysql_num_rows($result);
    }

    /* 返回结果集中字段 */

    public function numFields($result) {
        return @mysql_num_fields($result);
    }

    /* 返回最新一次插入操作返回的记录id */

    public function insertId() {
        return @mysql_insert_id($this->conn);
    }

    /* 释放结果集 */

    public function freeResult(&$result) {
        return @mysql_free_result($result);
    }

    /* 返回mysql错误编码 */

    private function errno() {
        return intval(@mysql_errno($this->conn));
    }

    /* 返回mysql错误信息 */

    private function error() {
        return @mysql_error($this->conn);
    }

    /* 中断操作，显示出错信息 */

    public function halt($sql, $msg = "") {
        $this->msg = "<b>SQL执行出错：</b>" . $sql . "<br/><b>错误编码：</b>" . $this->errno() . "<br/><b>错误信息：</b>" . $this->error() . "<br/>" . $msg;
        if ($this->debug) {
            echo '<div style="font-size:12px; text-align:left; border:1px solid #9cc9e0; padding:1px 4px; color:#000000; font-family:Arial,Helvetica,sans-serif;">' . $this->msg . '</div>';
            exit();
        }
    }

    /*
     * Description of __destruct
     * 析构函数，释放结果集，关闭数据库连接
     */

    public function __destruct() {
        if (!empty($this->result)) {
            $this->freeResult($this->result);
        }
        mysql_close($this->conn);
    }

}

?>
